import React, { useState } from 'react';
import { TableRow, TableCell } from "../../../elements/Table";
import { Icon, Box } from "../../../elements";
import { SessionItemProgress } from './SessionItemProgress';
import { SessionItemAction } from './SessionItemAction';
import { SessionItemDetails } from './SessionItemDetails';
import { SessionName } from './styles';
export var SessionItem = function (_a) {
    var session = _a.session;
    var _b = useState(false), expanded = _b[0], setExpanded = _b[1];
    var toggleExpanded = function () { return setExpanded(function (exp) { return !exp; }); };
    return (React.createElement(React.Fragment, null,
        React.createElement(TableRow, { onClick: toggleExpanded, selected: expanded, highlighted: session.started },
            React.createElement(TableCell, { small: true },
                React.createElement(Box, { direction: "row", verticalAlign: "center", height: "3.5em" },
                    React.createElement(Icon, { name: "chevron-right", bordered: true, size: "mini", rotate: expanded }),
                    React.createElement(SessionName, { title: session.name }, session.name))),
            React.createElement(TableCell, { small: true },
                React.createElement(SessionItemProgress, { progress: session.progress })),
            React.createElement(TableCell, { small: true, width: 155 },
                React.createElement(SessionItemAction, { actions: session.actions }))),
        expanded && (React.createElement(TableRow, { selected: true, highlighted: session.started },
            React.createElement(TableCell, { colSpan: 3 },
                React.createElement(SessionItemDetails, { session: session }))))));
};
