var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var _a;
import React, { useState } from 'react';
import { useTheme } from "../../../../../theme";
import { Button, Dropdown } from "../../../../inputs";
import { Tooltip, Header, Icon } from "../../../../elements";
import { Menu, MenuItem } from "../../../../collections";
import { automationRate } from '../data-templates';
import { ChartType } from '../utils';
import { ViewType } from '../../../types';
import { StackedBarChart } from '../../StackedBarChart';
import { StatisticPopoverBody } from './StatisticPopoverBody';
import { ChartWrapper } from './styles';
var getReminder = function (value) {
    return 100 - value;
};
var TITLES = (_a = {},
    _a[ChartType.weekly] = 'Weekly Display',
    _a[ChartType.monthly] = 'Monthly Display',
    _a[ChartType.annual] = 'Annual Display',
    _a);
var DROPDOWN_DATA = [
    {
        label: TITLES[ChartType.weekly],
        value: ChartType.weekly,
        key: ChartType.weekly,
    },
    {
        label: TITLES[ChartType.monthly],
        value: ChartType.monthly,
        key: ChartType.monthly,
    },
    {
        label: TITLES[ChartType.annual],
        value: ChartType.annual,
        key: ChartType.annual,
    },
];
export var StatisticsBarWrapper = function (_a) {
    var title = _a.title, setView = _a.setView, rateData = _a.rateData;
    var colors = useTheme().colors;
    var _b = useState(ChartType.weekly), activeChart = _b[0], setActiveChart = _b[1];
    var rateDataActiveChart = (rateData && rateData[activeChart]) || [];
    var stackedBarChartData = rateDataActiveChart.map(function (item) {
        var borderLine = Number(Boolean(item.value));
        return __assign(__assign({}, item), { borderLine: borderLine, from: getReminder(item.value + borderLine) });
    }) || [];
    var barList = [
        {
            dataKey: 'value',
            fillColor: colors.secondary.default,
        },
        {
            dataKey: 'borderLine',
            fillColor: colors.primary.saturated,
        },
        {
            dataKey: 'from',
            fillColor: '#ececec',
        },
    ];
    var axisProps = {
        axisLine: false,
        stroke: colors.primary.default,
        tickLine: false,
    };
    var gridProps = {
        vertical: false,
        stroke: '#d0d0d0',
    };
    var whatItIs = automationRate.whatItIs, howToImprove = automationRate.howToImprove, popoverTitle = automationRate.title;
    var popoverBody = (React.createElement(StatisticPopoverBody, { whatItIs: whatItIs, howToImprove: howToImprove }));
    return (React.createElement(React.Fragment, null,
        React.createElement(Menu, null,
            React.createElement(MenuItem, null,
                React.createElement(Button, { secondary: true, circular: true, color: "grey", onClick: function () { return setView(ViewType.overview); }, title: "Return to Statistics view" },
                    React.createElement(Icon, { name: "arrow-left", size: "medium", fitted: true }))),
            React.createElement(MenuItem, null,
                React.createElement(Header, { as: "h3", color: "grey" },
                    popoverTitle,
                    React.createElement(Tooltip, { children: popoverBody, placing: "right" }))),
            React.createElement(MenuItem, { position: "right" },
                React.createElement(Dropdown, { compact: true, value: activeChart, options: DROPDOWN_DATA, onClick: function (_, data) { return setActiveChart(data.value); } }))),
        React.createElement(ChartWrapper, null,
            React.createElement(StackedBarChart, { dataList: stackedBarChartData, barList: barList, axisProps: axisProps, gridProps: gridProps }))));
};
