import styled from 'styled-components';
import { Box } from "../../../elements";
import { ButtonType } from '../../types';
export var SessionsCountBox = styled.div.withConfig({ displayName: "SessionsCountBox", componentId: "sc-aiv8yb" })({
    flexBasis: 0,
    flexShrink: 1,
    flexGrow: 1,
    borderRadius: '0',
    position: 'relative',
    padding: '18px',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
}, function (_a) {
    var _b;
    var theme = _a.theme, btnType = _a.btnType;
    var backgroundColor = theme.colors.secondary.hover;
    if (btnType === ButtonType.primary) {
        backgroundColor = theme.colors.secondary.default;
    }
    else if (btnType === ButtonType.tertiary) {
        backgroundColor = theme.greyscale.light;
    }
    return _b = {
            backgroundColor: backgroundColor,
            color: btnType === ButtonType.tertiary
                ? theme.colors.primary.dark
                : theme.colors.white.default
        },
        _b["& > " + Box] = {
            transition: "0.2s filter, 0.2s opacity",
        },
        _b["&:hover > " + Box] = {
            filter: "blur(4px)",
            opacity: 0.75,
        },
        _b;
});
