import styled from 'styled-components';
import { clickable, primary, secondary } from "../../../utils";
import defaultTheme from "../../../theme";
export var Button = styled.button.withConfig({ displayName: "Button", componentId: "sc-1wt9ol7" })({
    minWidth: '135px',
    height: '35px',
    opacity: 1,
    outline: 'none',
    padding: '4px 12px',
    lineHeight: '2em',
    whiteSpace: 'nowrap',
    '& > i': {
        color: 'inherit',
    },
}, function (_a) {
    var theme = _a.theme;
    return ({
        borderRadius: theme.sizes.borderRadiusInput,
    });
}, function (props) { return (props.secondary ? secondary : primary); }, function (_a) {
    var fluid = _a.fluid;
    return (fluid ? { width: '100%' } : null);
}, function (_a) {
    var _b;
    var floated = _a.floated;
    return floated
        ? (_b = {},
            _b[floated === 'right' ? 'marginLeft' : 'marginRight'] = 'auto',
            _b) : null;
}, clickable, function (_a) {
    var circular = _a.circular;
    if (!circular) {
        return null;
    }
    return {
        width: '2.5em',
        height: '2.5em',
        minWidth: '2.5em',
        padding: '8px',
        borderRadius: '50%',
        boxSizing: 'border-box',
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
    };
}, function (_a) {
    var spaced = _a.spaced;
    switch (spaced) {
        case true:
            return { margin: "0 0.75em" };
        case 'left':
            return { marginLeft: '0.75em' };
        case 'right':
            return { marginRight: '0.75em' };
    }
});
Button.defaultProps = {
    theme: defaultTheme,
};
export default Button;
